# www.Tricks12345.com....Pandas Examples.. Template Last Updated July 3, 2018
#==========Import the Libraries====================
import pandas as pd;
import openpyxl;
#==========Create the DataFrame====================
rowsdata = [('Jan',24,48,47,22),('Feb',47,24,26,35),('Mar',47,18,36,98),('Apr',25,75,53,44),('May',62,75,44,68)]
index = ['Month','Apple', 'Orange', 'Grapes', 'Banana']
df = pd.DataFrame(rowsdata, columns =  index)
#=============Retrieve data based on conditions============
query = [('All Rows', df.ix[:],'df.ix[:]', 'Returns all the rows of DataFrame'),\
         ('SecondtoLast', df.ix[1:],'df.ix[1:]', 'Returns from second row to lastrow'),\
         ('SpecifiedRows', df.ix[0:3],'df.ix[0:3]', 'Returns from first row to third row'),\
         ('ExceptLastrow', df.iloc[0:-1],'df.iloc[0:-1]', 'Returns all the rows except last'),\
         ('AppleColumn', df.ix[1:3,['Apple']],'df.ix[1:3,["Apple"]]', 'Returns 3 rows with Apple column'),\
         ('Banana_Apple', df.ix[1:3,['Apple','Banana']],"df.ix[1:3,['Apple','Banana']]", 'Returns Banana,Apple Columns'),\
         ('Every Second Row', df.ix[::2], 'df.ix[::2]]', 'Prints every second row of dataframe'),\
         ('Every Third Row', df.ix[::3], 'df.ix[::3]]', 'Prints every Third row of dataframe'),\
         ('Secondrow fourth row', df.ix[[1,3]], 'df.ix[[1,3]]', 'Prints second row and fourth row'),\
         ('FirstThirdFourth', df.ix[[0,2,3]], 'df.ix[[0,2,3]]', 'Prints First Third Fourth rows of Dataframe'),\
         ('RowsNotInOrder', df.ix[[3,2,1]], 'df.ix[[3,2,1]]', 'We can chage the order of rows '),\
         ('HeadDF', df.head(), 'df.head()', 'Head by defalut returns 5 rows'),\
         ('HeadRowsSelect', df.head(3), 'df.head(3)', 'Returns first 3 rows of Dataframe'),\
         ('TailDF', df.tail(), 'df.tail()', 'Tail by defalut returns bottom 5 rows'),\
         ('TailThree', df.tail(3), 'df.tail(3)', 'Bottom 3 rows of DataFrame'),\
         ('FirstThree_iloc', df.iloc[0:3], 'df.iloc[0:3]', 'Prints first 3 rows'),\
         ('SecondThirdRows_iloc', df.iloc[1:3], 'df.iloc[1:3]', 'Prints  Second and Third rows'),\
         ('Rows Disorder', df.iloc[[4,2,1,3]], 'df.iloc[[4,2,1,3]]', 'We can change the order of rows'),\
         ('AllColumnsiloc', df.iloc[1:3,:], 'df.iloc[1:3,:]', 'Prints second and 3rd rows and all the columns'),\
         ('ColumnSliceiloc', df.iloc[1:3,1:3], 'df.iloc[1:3,1:3]', 'Slice the columns'),\
         ('RowColnSliceloc', df.loc[[2,1,4],['Banana','Orange']], "df.loc[[2,1,4],['Banana','Orange']]", 'Slice the rows and columns'),\
         ('ColumnsSliceloc', df.loc[1:3,'Orange':'Banana'], "df.loc[1:3,'Orange':'Banana']", 'Select the columns in range'),\
         ('ColumnsUptoloc', df.loc[1:3,:'Banana'], "df.loc[1:3,':'Banana']", 'Print the columns upto Banana'),\
         ('ColumnsFromloc', df.loc[1:3,'Orange':], "df.loc[1:3,'Orange':]", 'Print the columns from Orange'),\
         ('RowsFromThreeloc', df.loc[2:,'Orange':], "df.loc[2:,'Orange':]", 'Print the Rows and columns from 3 and Orange'),\
         ('UptoThirdRowloc', df.loc[:2,'Orange':], "df.loc[:2,'Orange':]", 'Print the Rows upto third')]  
        
#==Delete the existing sheets in workbook before running the program=======================
#======================================================================
wkb = openpyxl.load_workbook('Pandas_To_Excel.xlsm', read_only=False, keep_vba=True); sh =  wkb['Input'] 
for sheet in  wkb.sheetnames:
        worksh = wkb[sheet]
        if  worksh.title !=  'Input':  
           del wkb[worksh.title]
#==============Run the Program======================         
for i in range(len(query)):
    a = list(df.shape); r = a[0]; c = a[1]; shcount =  len(wkb.sheetnames)
    Newsh = wkb.create_sheet(index = int(shcount))
    for  rowdata in range(r):         
        Newsh.cell(row = int(rowdata)+5, column =  2).value = rowdata
        for columndata in range(c):
            result =  df.iloc[rowdata,columndata]        
            Newsh.cell(row = int(rowdata)+5, column = int(columndata)+3).value = result        
    q = len((list(df.columns)))
    for h in range(q):
         Newsh.cell(row = 3, column = int(h)+3).value = int(h)
         Newsh.cell(row = 4, column = int(h)+3).value = df.columns[h]
    Newsh.title =  query[i][0]
    #==================result table==================
    df1 = query[i][1]; b = list(df1.shape); rows = b[0]; cols = b[1]     
    for  rowsdata in range(rows):         
         for colsdata in range(cols):
            output =  df1.iloc[rowsdata,colsdata]  
            Newsh.cell(row = int(rowsdata)+5, column = int(colsdata)+11).value = output        
    q = len(list(df1.columns))
    for h in range(q):          
         Newsh.cell(row = 4, column = int(h)+11).value = df1.columns[h]
    Newsh.cell(row = 15, column = 5).value = str(query[i][2])
    Newsh.cell(row = 16, column = 5).value = query[i][3]
    Newsh.cell(row = 13, column = 13).value = 'www.Tricks12345.com'
    wkb.save('Pandas_To_Excel.xlsm')    
print('completed')

